import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"pascal","displayName":"Pascal","description":"Pascal language support for Visual Studio Code","version":"9.6.0","publisher":"alefragnani","galleryBanner":{"color":"#4682B4","theme":"dark"},"engines":{"vscode":"^1.74.0"},"categories":["Programming Languages","Snippets","Other"],"keywords":["pascal","delphi","freepascal","lazarus","multi-root ready"],"activationEvents":["onStartupFinished"],"capabilities":{"virtualWorkspaces":{"supported":"limited","description":"In virtual workspaces, code navigation features are not supported."},"untrustedWorkspaces":{"supported":"limited","description":"Trust is required to be able to use code navigation features in this workspace.","restrictedConfigurations":["pascal.tags.autoGenerate","pascal.codeNavigation"]}},"icon":"images/icon.png","license":"SEE LICENSE IN LICENSE.md","homepage":"https://github.com/alefragnani/vscode-language-pascal/blob/master/README.md","repository":{"type":"git","url":"https://github.com/alefragnani/vscode-language-pascal.git"},"bugs":{"url":"https://github.com/alefragnani/vscode-language-pascal/issues"},"sponsor":{"url":"https://github.com/sponsors/alefragnani"},"contributes":{"languages":[{"id":"pascal","aliases":["Pascal","pascal"],"extensions":[".pas",".p",".dfm",".fmx",".dpr",".dpk",".lfm",".dpr",".lpr"],"configuration":"./pascal.configuration.json"}],"grammars":[{"language":"pascal","scopeName":"source.pascal","path":"./syntaxes/pascal.tmLanguage"}],"snippets":[{"language":"pascal","path":"./snippets/pascal.json"}],"configuration":{"type":"object","title":"%pascal.configuration.title%","properties":{"pascal.tags.autoGenerate":{"type":"boolean","default":true,"description":"%pascal.configuration.tags.autoGenerate.description%"},"pascal.codeNavigation":{"type":"string","default":"workspace","scope":"resource","description":"%pascal.configuration.codeNavigation.description%","enum":["workspace","file"]}}}},"eslintConfig":{"extends":["vscode-ext"]},"scripts":{"build":"webpack --mode development","watch":"webpack --watch --mode development","vscode:prepublish":"webpack --mode production","webpack":"webpack --mode development","webpack-dev":"webpack --mode development --watch","compile":"tsc -p ./","lint":"eslint -c package.json --ext .ts src vscode-whats-new","pretest":"npm run compile && npm run lint","test-compile":"tsc -p ./ && npm run webpack","just-test":"node ./out/src/test/runTest.js","test":"npm run test-compile && npm run just-test"},"devDependencies":{"@types/glob":"^7.1.4","@types/mocha":"^9.0.0","@types/node":"^14.17.27","@types/vscode":"^1.73.0","@typescript-eslint/eslint-plugin":"^5.1.0","@typescript-eslint/parser":"^5.1.0","@vscode/test-electron":"^1.6.2","eslint":"^8.1.0","eslint-config-vscode-ext":"^1.1.0","glob":"^7.1.7","mocha":"^9.1.3","terser-webpack-plugin":"^5.2.4","ts-loader":"^9.2.5","typescript":"^4.4.4","webpack":"^5.52.1","webpack-cli":"^4.8.0"}};

const { registerFileUrl, whenReady } = registerExtension(manifest);


registerFileUrl('syntaxes/pascal.tmLanguage', new URL('../assets/alefragnani.pascal-9.6.0.vsix/pascal.tmLanguage', import.meta.url).href);

registerFileUrl('pascal.configuration.json', new URL('../assets/alefragnani.pascal-9.6.0.vsix/pascal.configuration.json', import.meta.url).href, 'application/json');

registerFileUrl('snippets/pascal.json', new URL('../assets/alefragnani.pascal-9.6.0.vsix/pascal.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/alefragnani.pascal-9.6.0.vsix/package.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.json', new URL('../assets/alefragnani.pascal-9.6.0.vsix/package.nls.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.pt-br.json', new URL('../assets/alefragnani.pascal-9.6.0.vsix/package.nls.pt-br.json', import.meta.url).href, 'application/json');

export { whenReady };
