import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"vscode-django","displayName":"Django","description":"Beautiful syntax and scoped snippets for perfectionists with deadlines","version":"1.15.0","publisher":"batisteo","license":"MIT","icon":"images/vscode-django-icon.png","galleryBanner":{"color":"#0c4b33","theme":"dark"},"engines":{"vscode":"^1.49.0"},"recommendations":["ms-python.python"],"keywords":["python","django","web"],"categories":["Programming Languages","Snippets"],"homepage":"https://github.com/vscode-django/vscode-django","repository":{"type":"git","url":"https://github.com/vscode-django/vscode-django"},"bugs":{"url":"https://github.com/vscode-django/vscode-django/issues"},"activationEvents":["onLanguage:django-html","onLanguage:django-txt","onLanguage:python"],"scripts":{"vscode:prepublish":"yarn run compile","compile":"tsc -p ./","lint":"eslint src --ext ts","watch":"tsc -watch -p ./","pretest":"yarn run compile && yarn run lint","test":"yarn run compile && node ./node_modules/vscode/bin/test","compile-web":"webpack","watch-web":"webpack","package-web":"webpack --mode production --devtool hidden-source-map","chrome":"vscode-test-web --browserType=chromium --extensionDevelopmentPath=. ."},"dependencies":{"path":"^0.12.7","toml":"^3"},"devDependencies":{"@types/glob":"^7.1.3","@types/mocha":"^8.0.0","@types/node":"^12.11.7","@types/vscode":"^1.48.0","@typescript-eslint/eslint-plugin":"^4.1.1","@typescript-eslint/parser":"^4.1.1","eslint":"^7.9.0","glob":"^7.1.6","mocha":"^8.1.3","typescript":"^4.0.2","vscode-test":"^1.4.0","ts-loader":"^9.2.2","webpack":"^5.38.1","webpack-cli":"^4.7.0","@vscode/test-web":"^0.0.11"},"contributes":{"languages":[{"id":"django-html","aliases":["Django HTML","django"],"filenamePatterns":["**/templates/**/*.html"],"firstLine":"{%","configuration":"./language-configuration.json"},{"id":"django-txt","aliases":["Django txt","django"],"filenamePatterns":["**/templates/**/*"],"firstLine":"{%","configuration":"./language-configuration.json"}],"grammars":[{"language":"django-html","scopeName":"text.html.django","path":"./syntaxes/django-html.tmLanguage.json"},{"language":"django-txt","scopeName":"text.django","path":"./syntaxes/django-txt.tmLanguage.json"}],"snippets":[{"language":"django-html","path":"./snippets/templates/tags.json"},{"language":"django-html","path":"./snippets/templates/filters.json"},{"language":"django-txt","path":"./snippets/templates/tags.json"},{"language":"django-txt","path":"./snippets/templates/filters.json"}],"configurationDefaults":{"[django-html]":{"editor.quickSuggestions":{"other":true,"comments":true,"strings":true}}},"configuration":{"type":"object","title":"Django configuration","properties":{"django.snippets.use":{"type":"boolean","default":true,"description":"Activates the Python snippets"},"django.snippets.exclude":{"type":"array","default":["cms","wagtail"],"description":"Exclude Python snippets by their file name. Can be 'import', 'postgres'..."},"django.i18n":{"type":"boolean","default":true,"description":"Activates the i18n features for snippets (eg.: _(\"\"))"},"django.showContributeNotification":{"type":"boolean","default":true,"description":"Seldom show notifications about this extension"}}}}};

const { registerFileUrl, whenReady } = registerExtension(manifest);


registerFileUrl('syntaxes/django-html.tmLanguage.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/django-html.tmLanguage.json', import.meta.url).href, 'application/json');

registerFileUrl('syntaxes/django-txt.tmLanguage.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/django-txt.tmLanguage.json', import.meta.url).href, 'application/json');

registerFileUrl('language-configuration.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/language-configuration.json', import.meta.url).href, 'application/json');

registerFileUrl('snippets/templates/tags.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/tags.json', import.meta.url).href, 'application/json');

registerFileUrl('snippets/templates/filters.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/filters.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/package.json', import.meta.url).href, 'application/json');

export { whenReady };
