import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"Kotlin","displayName":"Kotlin Language","description":"Kotlin language support for VS Code","version":"1.7.1","publisher":"mathiasfrohlich","license":"Apache-2.0","scripts":{"package":"./node_modules/.bin/vsce package"},"engines":{"vscode":"^1.8.0"},"icon":"artwork/icon.png","categories":["Programming Languages"],"bugs":{"url":"https://github.com/mathiasfrohlich/vscode-kotlin/issues"},"homepage":"https://github.com/mathiasfrohlich/vscode-kotlin","repository":{"type":"git","url":"https://github.com/mathiasfrohlich/vscode-kotlin.git"},"keywords":["Kotlin","kotlin","kt","kts"],"contributes":{"languages":[{"id":"kotlin","aliases":["Kotlin","kotlin"],"extensions":[".kt"],"configuration":"./kotlin.configuration.json"},{"id":"kotlinscript","aliases":["Kotlinscript","kotlinscript"],"extensions":[".kts"],"configuration":"./kotlin.configuration.json"}],"grammars":[{"language":"kotlin","scopeName":"source.kotlin","path":"./syntaxes/Kotlin.tmLanguage"},{"language":"kotlinscript","scopeName":"source.kotlin","path":"./syntaxes/Kotlin.tmLanguage"},{"scopeName":"markdown.kotlin.codeblock","path":"./syntaxes/codeblock.json","injectTo":["text.html.markdown"],"embeddedLanguages":{"meta.embedded.block.kotlin":"kotlin"}}],"snippets":[{"language":"kotlin","path":"./snippets/kotlin.json"},{"language":"kotlinscript","path":"./snippets/kotlin.json"}]},"devDependencies":{"vsce":"^1.36.2","vscode":"0.11.x","vso-node-api":"6.1.2-preview"},"__metadata":{"id":"d36bad53-910d-481a-a7ee-8992450665f6","publisherId":"6c0520a7-c10a-45a4-b172-d75ca7dca2c1","publisherDisplayName":"mathiasfrohlich"}};

const { registerFileUrl, whenReady } = registerExtension(manifest);


registerFileUrl('syntaxes/Kotlin.tmLanguage', new URL('../assets/mathiasfrohlich.Kotlin-1.7.1.vsix/Kotlin.tmLanguage', import.meta.url).href);

registerFileUrl('syntaxes/codeblock.json', new URL('../assets/mathiasfrohlich.Kotlin-1.7.1.vsix/codeblock.json', import.meta.url).href, 'application/json');

registerFileUrl('kotlin.configuration.json', new URL('../assets/mathiasfrohlich.Kotlin-1.7.1.vsix/kotlin.configuration.json', import.meta.url).href, 'application/json');

registerFileUrl('snippets/kotlin.json', new URL('../assets/mathiasfrohlich.Kotlin-1.7.1.vsix/kotlin.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/mathiasfrohlich.Kotlin-1.7.1.vsix/package.json', import.meta.url).href, 'application/json');

export { whenReady };
